package com.ycs.fe.util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Map.Entry;



import org.apache.log4j.Logger;
import org.apache.struts2.ServletActionContext;
import org.dom4j.Element;
import org.dom4j.Node;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.LocaleProvider;
import com.opensymphony.xwork2.TextProvider;
import com.opensymphony.xwork2.TextProviderFactory;
import com.ycs.fe.dto.PrepstmtDTO;
import com.ycs.fe.dto.PrepstmtDTO.DataType;
import com.ycs.fe.dto.ResultDTO;
import com.ycs.fe.exception.DataTypeException;
import com.ycs.fe.exception.FrontendException;
import com.ycs.fe.exception.ValidationException;

public class FEValidator  implements LocaleProvider{

	private static Logger logger = Logger.getLogger(FEValidator.class);
	private TextProvider textProvider;
	private ResultDTO resultDTO = new ResultDTO();
	public ResultDTO validate(String screenName, Map<String,Object> submitdataObj) throws ValidationException{
		try{
		Element rootElm = ScreenMapRepo.findMapXMLRoot(screenName);
		
		Map<String,Object> s = (Map<String,Object>)submitdataObj;
		for (Entry<String, Object> itr : s.entrySet()) { //form1, form2 ...skip txnrec, sessionvars, bulkcmd
			if(itr.getKey().equals("sessionvars")){
				//These will be most likely have not yet been set, validate directly from sessoin variable
				Map<String,Object> sessvars = (Map<String,Object>) itr.getValue();
				System.out.println("Need to validate these:"+ sessvars);
			}else if(itr.getKey().equals("bulkcmd")){
				//do nothing
			}else if(itr.getKey().equals("txnrec")){
				Map<String,Object> txnrec = (Map<String,Object>) itr.getValue();
				Map<String,Object> singlerec = (Map<String,Object>) txnrec.get("single"); //object
				for (Iterator keyitr = singlerec.keySet().iterator(); keyitr.hasNext();) {
					String keystr = (String) keyitr.next();
					validateNode(screenName, rootElm, singlerec, keystr, null);
				} 
				List armultirec = (List) txnrec.get("multiple"); //array
				for (Iterator iterator = armultirec.iterator(); iterator.hasNext();) { //rows
					Map<String,Object> joMulti = (Map<String,Object>) iterator.next(); //each row
					for (Iterator keyitr = joMulti.keySet().iterator(); keyitr.hasNext();) {
						String keystr = (String) keyitr.next();
						validateNode(screenName, rootElm, joMulti, keystr, null);
					} 
				}  
			}else{ //form1,form2 ... data vaalidation
				List rows =  (List) itr.getValue();
				for (Iterator iterator = rows.iterator(); iterator.hasNext();) { //rows
					Map<String,Object> joMulti = (Map<String,Object>) iterator.next(); //each row
					for (Iterator keyitr = joMulti.keySet().iterator(); keyitr.hasNext();) {
						String keystr = (String) keyitr.next();
						validateNode(screenName, rootElm, joMulti, keystr, null);
					} 
				}
			}
		}
		
		validateSessionVariables(screenName);
		}catch(FrontendException e){
			throw new ValidationException("error.validationfailed",e);
		}
		return resultDTO;
	}

	private void validateSessionVariables(String screenName) throws ValidationException{
		try{
		Element rootElm = ScreenMapRepo.findMapXMLRoot(screenName);
		Node sessionVar = rootElm.selectSingleNode("/root/screen/sessionvars");
		   if(sessionVar != null){
			String strSessionVar = sessionVar.getText();
			Map<String, String> sessionMap = new HashMap<String,String>();
			if(strSessionVar != null || !"".equals(strSessionVar)){
				String[] arSessionVar = strSessionVar.split(",");
				if(arSessionVar.length >0){
					for (String sessVariable : arSessionVar) {
							String[] sessionField = sessVariable.trim().split("\\|");
						String sessionData = "";
						if(sessionField.length >1){
							//datatype is defined and it is required
								sessionData = (String) ServletActionContext.getContext().getSession().get(sessionField[0]);
								System.out.println("sessionData:"+sessionData);
//							if(sessionField[1].equals("INT")){
//								sessionData.matches("0-9");
//							}
							Map<String,Object> sessionJson = new HashMap<String,Object>();
							sessionJson.put(sessionField[0], sessionData);
							validateNode(screenName, rootElm, sessionJson, sessionField[0], sessionField[1]);
						}
						sessionMap.put(sessionField[0], sessionData);
					}
				}
			}
		   }
		}  catch(FrontendException e){
			throw new ValidationException("error.validationsessionvar",e);
		}
	}

	private void validateNode(String screenName, Element rootElm,
			Map<String,Object> singlerec, String keystr, String overrideDatatype) {
		Element fieldNode = (Element) rootElm.selectSingleNode("/root/panels/panel/fields/field/*[@name='"+keystr+"']");
		if (fieldNode != null) {
			String strdbdatatype = fieldNode.attributeValue("dbdatatype");
			String strdbcolsize = fieldNode.attributeValue("dbcolsize");
			String strmandatory = fieldNode.attributeValue("mandatory");
			String fieldName = fieldNode.attributeValue("name");
			String strLabel = LabelFactory.INSTANCE.getLabel(screenName, fieldName );
			
			int colsize = -1;
			
			if(overrideDatatype != null && !"".equals(overrideDatatype)){
				strdbdatatype = overrideDatatype;
			}
			
			if (strdbcolsize != null && !"".equals(strdbcolsize)) {
				colsize = Integer.parseInt(strdbcolsize);
			}
			String singleRecStr = (String) singlerec.get(keystr); //string
			try {
				DataType dbdatatype = PrepstmtDTO.getDataTypeFrmStr(strdbdatatype);
				if (dbdatatype == DataType.STRING) {
//					System.out.println("Validating string.....");
//					addError("error.numberformat", keystr, strLabel,							singlerec.getString(keystr));
					// filtering criterion required?
				} else if (dbdatatype == DataType.INT) {
					try {
						if(singleRecStr!=null && !"".equals(singleRecStr))
						Integer.parseInt(singleRecStr);
					} catch (NumberFormatException e) {
						addError("error.numberformat", keystr, strLabel,
								singleRecStr);
					}
				} else if (dbdatatype == DataType.FLOAT) {
					try {
						if(singleRecStr!=null && !"".equals(singleRecStr))
						Float.parseFloat(singleRecStr);
					} catch (NumberFormatException e) {
						addError("error.float", keystr, strLabel,
								singleRecStr);
					}
				} else if (dbdatatype == DataType.DOUBLE) {
					try {
						if (singleRecStr != null && !"".equals(singleRecStr))
							Double.parseDouble(singleRecStr);
					} catch (NumberFormatException e) {
						addError("error.double", keystr, strLabel,
								singleRecStr);
					}
				} else if (dbdatatype == DataType.DATEDDMMYYYY) {
					try {
						if (singleRecStr != null && !"".equals(singleRecStr))
							new SimpleDateFormat("DD/MM/yyyy").parse(singleRecStr);
					} catch (ParseException e) {
						addError("error.dateDDMMyyyy", keystr, strLabel,
								singleRecStr);
					}
				} else if (dbdatatype == DataType.DATE_NS) {
					try {
						if (singleRecStr != null && !"".equals(singleRecStr))
							new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS")
									.parse(singleRecStr);
					} catch (ParseException e) {
						addError("error.date_ns", keystr, strLabel,
								singleRecStr);
					}
				} else if (dbdatatype == DataType.TIMESTAMP) {
					try {
						if (singleRecStr != null && !"".equals(singleRecStr))
							new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS")
									.parse(singleRecStr);
					} catch (ParseException e) {
						addError("error.timestamp", keystr, strLabel,
								singleRecStr);
					}
				}
			} catch (DataTypeException e) {
				logger.error("datatype undefined", e);
				addError("error.datatypeundefined", keystr, strLabel,
						singleRecStr);
			}
			if (strmandatory != null
					&& ("yes".equals(strmandatory) || "true"
							.equals(strmandatory))) {
				if (singleRecStr.length() < 1) {
					addError("error.mandatory", keystr,	strLabel, singleRecStr);
				}
			}
			if (colsize != -1 && singleRecStr.length() > colsize) {
				addError("error.colsize", keystr, strLabel, singleRecStr);
			}
		}//field not is not defined for this key like 'command' 
		else{
			logger .debug("xml not defined for key="+keystr);
		}
	}
	
	private void addError(String messageKey, String fieldName, String fieldLabel, String fieldValue) {
//		if(fieldLabel != null && !"".equals(fieldLabel))fieldName = fieldLabel;
		
		String [] str2 = new String[]{ fieldLabel, fieldValue };
		logger.error("validation :"+getTextProvider().getText(messageKey,str2 )+" field=["+fieldName+"] val="+fieldValue);
		
		resultDTO.addFieldError(fieldName, getTextProvider().getText(messageKey,str2 ));
	}

	public String createJSRule(String screenName ){
		String ruleJson = "";
		String fieldGroupRules = "";
		String fieldGroupMsg  = "";
		boolean fieldRulesFirst = true;
		try{
			Element rootElm = ScreenMapRepo.findMapXMLRoot(screenName);
			List<Element> fieldNodeList =   rootElm.selectNodes("/root/panels/panel/fields/field/*[@name]");
			for (Element fieldNode : fieldNodeList) {
				
			
				if (fieldNode != null) {
					String strdbdatatype = fieldNode.attributeValue("dbdatatype");
					String strdbcolsize = fieldNode.attributeValue("dbcolsize");
					String strmandatory = fieldNode.attributeValue("mandatory");
					String fieldName = fieldNode.attributeValue("name");
					String strLabel = LabelFactory.INSTANCE.getLabel(screenName, fieldName );
					int colsize = -1;
					if (strdbcolsize != null && !"".equals(strdbcolsize)) {
						colsize = Integer.parseInt(strdbcolsize);
					}
					Map<String,Object> rules = new HashMap<String,Object>();
					Map<String,Object> messages = new HashMap<String,Object>();
					Map<String,Object> field = new HashMap<String,Object>();
					
					String fldRuleStr = "";
					String fldMsgStr = "";
					boolean first1 =  true;
					if (strmandatory != null
							&& ("yes".equals(strmandatory) || "true"
									.equals(strmandatory))) {
						field.put("required", true);
						if(!first1){fldRuleStr += ","; fldMsgStr +=","; }first1 = false;
						fldRuleStr ="required: true";
						fldMsgStr = "required: '"+strLabel+" is required'";
					}
					if(strdbcolsize != null && !"".equals(strdbcolsize)){
						if(!first1){fldRuleStr += ","; fldMsgStr +=","; }first1 = false;
						fldRuleStr += "maxlength:"+strdbcolsize;
						fldMsgStr += "maxlength: 'The length of "+strLabel+" should be less than {0}'";
					}
					if(strdbdatatype != null && !"".equals(strdbdatatype)){
						DataType type = PrepstmtDTO.getDataTypeFrmStr(strdbdatatype);
						switch(type){
					  	case INT: 
					  	case LONG:
					  		if(!first1){fldRuleStr += ","; fldMsgStr +=","; }first1 = false;
					  			fldRuleStr += "integer:true";
					  			fldMsgStr += "integer: '"+strLabel+" must be integer'";break;
					  	case FLOAT: 
					  	case DOUBLE:
					  		if(!first1){fldRuleStr += ","; fldMsgStr +=","; }first1 = false;
					  			fldRuleStr += "number:true";
			  					fldMsgStr += "number: '"+strLabel+" must be decimal'";break;
					  	case DATEDDMMYYYY:
					  		if(!first1){fldRuleStr += ","; fldMsgStr +=","; }first1 = false;
						  		fldRuleStr += "dateITA:true";
			  					fldMsgStr += "dateITA: '"+strLabel+" must be date'";break;
					  	case DATE_NS:
					  	case TIMESTAMP:
					  		if(!first1){fldRuleStr += ","; fldMsgStr +=","; }first1 = false;
						  		fldRuleStr += "date:true";
			  					fldMsgStr += "number: '"+strLabel+" must be date'";break;
						case STRING:
							default:
						}
					}
					if(fldRuleStr.length() > 1){
						if(!fieldRulesFirst){
						fieldGroupRules += ",";
						fieldGroupMsg += ",";
						}
						fieldRulesFirst = false;
						fieldGroupRules += ""+fieldName+":{"+fldRuleStr+"}";
						fieldGroupMsg += ""+fieldName+":{"+fldMsgStr+"}";
					}
					
				}
			}
			if(fieldGroupRules.length() > 1){
				ruleJson += "{rules: {"+fieldGroupRules+"}, messages: {"+fieldGroupMsg+"}}";
			}
		} catch (FrontendException e) {
			logger.error("error.xmlfileaccess",e);
		} catch (Exception e) {
			logger.error("error.unknown",e);
		}
		return ruleJson;
	}
	
	private TextProvider getTextProvider()
	{
	  if (this.textProvider == null) {
	    TextProviderFactory tpf = new TextProviderFactory();
	     
	    this.textProvider = tpf.createInstance(super.getClass(), this);
	  }
	  return   this.textProvider;
	}

	@Override
	public Locale getLocale() {
		 ActionContext ctx = ActionContext.getContext();
		  if (ctx != null) {
		    return ctx.getLocale();
		  }
		  System.out.println("Action context not initialized");
		  return null;
	}
	
	public static void main(String[]  args){
		new FEValidator().createJSRule("ProgramSetup");
		
	}

}
